/*
 Navicat MySQL Data Transfer

 Source Server         : localhost
 Source Server Version : 50639
 Source Host           : localhost
 Source Database       : ppgo_job2

 Target Server Version : 50639
 File Encoding         : utf-8

 Date: 08/09/2018 12:22:47 PM
*/

SET NAMES utf8;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
--  Table structure for `pp_task`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task`;
CREATE TABLE `pp_task` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `group_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '分组ID',
  `server_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '服务器id',
  `task_name` varchar(50) NOT NULL DEFAULT '' COMMENT '任务名称',
  `description` varchar(200) NOT NULL DEFAULT '' COMMENT '任务描述',
  `cron_spec` varchar(100) NOT NULL DEFAULT '' COMMENT '时间表达式',
  `concurrent` tinyint(4) unsigned NOT NULL DEFAULT '0' COMMENT '是否只允许一个实例',
  `command` text NOT NULL COMMENT '命令详情',
  `timeout` smallint(6) unsigned NOT NULL DEFAULT '0' COMMENT '超时设置 s',
  `execute_times` int(11) NOT NULL DEFAULT '0' COMMENT '累计执行次数',
  `prev_time` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '上次执行时间',
  `is_notify` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0-不通知，1-通知',
  `notify_type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0-邮件通知，1-信息通知，',
  `notify_user_ids` varchar(200) NOT NULL DEFAULT '0' COMMENT '通知用户ID字符串，1,2,3',
  `status` tinyint(4) NOT NULL DEFAULT '2' COMMENT '-1删除，0停用 1启用 2审核中,3不通过',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `create_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建者ID',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次编辑时间',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '最后一次编辑者ID',
  PRIMARY KEY (`id`),
  KEY `idx_group_id` (`group_id`)
) ENGINE=InnoDB AUTO_INCREMENT=11 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `pp_task`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task` VALUES ('1', '3', '2', '打印服务器内存', '2秒钟一次', '*/2 * * * *', '0', 'free -G', '0', '334', '1531645982', '0', '0', '0', '0', '1497855526', '0', '1531644960', '1'), ('2', '2', '1', '外部测试服务器', '8秒钟一次', '*/8 * * * * *', '0', 'echo \"hello world \\n\" >> /tmp/ppgo.log&& echo \"Hello world\"', '0', '151', '1531462016', '0', '0', '0', '2', '1502876155', '0', '1531645495', '1'), ('3', '1', '1', '审核不通过的任务测试', '2s执行一次', '*/2 *  *  *  *', '0', '/webroot/server/php/bin/php /webroot/www/default/test2.php', '0', '26', '1531275962', '0', '0', '0', '2', '1502936077', '0', '1531644281', '1'), ('4', '2', '0', '输出错误', '5秒执行一次', '*/5 * * * *', '0', 'tthh', '0', '72', '1531722855', '0', '0', '0', '0', '1502945973', '0', '1531645619', '1'), ('5', '1', '0', '密码验证任务112', '5秒执行一次', '*/5 * * * *', '0', '/webroot/server/php/bin/php /webroot/www/default/test2.php', '0', '29', '1531468808', '0', '0', '0', '3', '1503991581', '0', '1531723027', '1'), ('6', '1', '0', '打印并输出', '10秒一次，打印 hello ppgo_job', '*/10 * * * *', '0', 'echo \"hello ppgo_job\\n\" >> /tmp/test_ppgo.log', '0', '162', '1531722930', '0', '0', '0', '0', '1530599445', '1', '1531644960', '1'), ('7', '3', '1', '打印ppgo', '5秒一次', '*/5 * * * * *', '0', 'echo \"hello ppgo\\n\" >> /tmp/ppgo.log&&echo \"yes\\n\"', '0', '108', '1531645980', '0', '0', '0', '0', '1530761019', '1', '1531645347', '1'), ('8', '3', '3', '查看网络情况', '5秒一次', '*/5 * * * * *', '0', 'ifconfig', '0', '59', '1531645980', '0', '0', '0', '0', '1531468119', '1', '1531645083', '1'), ('9', '1', '0', '查看磁盘情况-短信', '5秒一次', '*/5 * * * * *', '0', 'df -h', '0', '46', '1531722935', '1', '1', '5,3,2', '0', '1531468712', '1', '1533702062', '1'), ('10', '1', '0', '测试通知通知的任务', '用于测试通知邮件的任务', '0 */5 * * *', '0', 'sleep 1s & lsss', '1', '22', '1533783831', '1', '0', '2', '0', '1533697794', '1', '1533781696', '1');
COMMIT;

-- ----------------------------
--  Table structure for `pp_task_ban`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task_ban`;
CREATE TABLE `pp_task_ban` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `code` varchar(64) NOT NULL DEFAULT '0' COMMENT '命令',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0-正常，1-删除',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='权限和角色关系表';

-- ----------------------------
--  Records of `pp_task_ban`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task_ban` VALUES ('1', 'rm -rf', '1528639322', '1528639692', '0'), ('2', 'dd if=/dev/random of=/dev/sda', '1528639322', '1528639588', '0'), ('3', 'mkfs.ext3 /dev/sda', '1528639445', '0', '0');
COMMIT;

-- ----------------------------
--  Table structure for `pp_task_group`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task_group`;
CREATE TABLE `pp_task_group` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `group_name` varchar(50) NOT NULL DEFAULT '' COMMENT '组名',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  `create_id` int(11) NOT NULL DEFAULT '0' COMMENT '用户ID',
  `create_time` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改者Id',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态：1-正常，0-删除',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`create_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `pp_task_group`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task_group` VALUES ('1', '任务分组甲', '任务分组甲', '1', '1531643000', '1', '1531643000', '1'), ('2', '任务分组乙', '任务分组乙', '1', '1531643030', '1', '1531643030', '1'), ('3', '任务分组丙', '任务分组丙', '1', '1531643070', '1', '1531643070', '1');
COMMIT;

-- ----------------------------
--  Table structure for `pp_task_log`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task_log`;
CREATE TABLE `pp_task_log` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `task_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '任务ID',
  `output` mediumtext NOT NULL COMMENT '任务输出',
  `error` text NOT NULL COMMENT '错误信息',
  `status` tinyint(4) NOT NULL COMMENT '状态',
  `process_time` int(11) NOT NULL DEFAULT '0' COMMENT '消耗时间/毫秒',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  PRIMARY KEY (`id`),
  KEY `idx_task_id` (`task_id`,`create_time`)
) ENGINE=InnoDB AUTO_INCREMENT=410 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `pp_task_log`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task_log` VALUES ('1', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:19815 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:9732 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28901272 (27.5 MiB)  TX bytes:606185 (591.9 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '365', '1531645278'), ('2', '7', 'yes\\n\n', '', '0', '436', '1531645325'), ('3', '7', 'yes\\n\n', '', '0', '319', '1531645375'), ('4', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '21', '1531645573'), ('5', '1', '', 'Process exited with status 1:', '-1', '293', '1531645698'), ('6', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645700'), ('7', '6', '', '', '0', '14', '1531645700'), ('8', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663541 41176073   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '18', '1531645700'), ('9', '7', 'yes\\n\n', '', '0', '448', '1531645700'), ('10', '1', '', 'Process exited with status 1:', '-1', '596', '1531645700'), ('11', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:19911 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:9799 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28912798 (27.5 MiB)  TX bytes:619389 (604.8 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '632', '1531645700'), ('12', '1', '', 'Process exited with status 1:', '-1', '252', '1531645702'), ('13', '1', '', 'Process exited with status 1:', '-1', '312', '1531645704'), ('14', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '13', '1531645705'), ('15', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663541 41176073   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645705'), ('16', '7', 'yes\\n\n', '', '0', '423', '1531645705'), ('17', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:19999 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:9861 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28923348 (27.5 MiB)  TX bytes:631959 (617.1 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '454', '1531645705'), ('18', '1', '', 'Process exited with status 1:', '-1', '318', '1531645706'), ('19', '1', '', 'Process exited with status 1:', '-1', '310', '1531645708'), ('20', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663541 41176073   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '11', '1531645710'), ('21', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '12', '1531645710'), ('22', '6', '', '', '0', '12', '1531645710'), ('23', '7', 'yes\\n\n', '', '0', '356', '1531645710'), ('24', '1', '', 'Process exited with status 1:', '-1', '394', '1531645710'), ('25', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20115 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:9946 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28937354 (27.5 MiB)  TX bytes:648771 (633.5 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '432', '1531645710'), ('26', '1', '', 'Process exited with status 1:', '-1', '452', '1531645712'), ('27', '1', '', 'Process exited with status 1:', '-1', '339', '1531645714'), ('28', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645715'), ('29', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663549 41176065   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645715'), ('30', '7', 'yes\\n\n', '', '0', '327', '1531645715'), ('31', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20203 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10010 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28947904 (27.6 MiB)  TX bytes:661461 (645.9 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '360', '1531645715'), ('32', '1', '', 'Process exited with status 1:', '-1', '236', '1531645716'), ('33', '1', '', 'Process exited with status 1:', '-1', '233', '1531645718'), ('34', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663554 41176060   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645720'), ('35', '6', '', '', '0', '15', '1531645720'), ('36', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '18', '1531645720'), ('37', '7', 'yes\\n\n', '', '0', '333', '1531645720'), ('38', '1', '', 'Process exited with status 1:', '-1', '434', '1531645720'), ('39', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20318 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10094 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28961908 (27.6 MiB)  TX bytes:678299 (662.4 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '443', '1531645720'), ('40', '1', '', 'Process exited with status 1:', '-1', '234', '1531645722'), ('41', '1', '', 'Process exited with status 1:', '-1', '237', '1531645724'), ('42', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '9', '1531645725'), ('43', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663546 41176068   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '14', '1531645725'), ('44', '7', 'yes\\n\n', '', '0', '372', '1531645725'), ('45', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20405 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10155 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28972456 (27.6 MiB)  TX bytes:690883 (674.6 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '454', '1531645725'), ('46', '1', '', 'Process exited with status 1:', '-1', '227', '1531645726'), ('47', '1', '', 'Process exited with status 1:', '-1', '304', '1531645728'), ('48', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663546 41176068   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '11', '1531645730'), ('49', '6', '', '', '0', '11', '1531645730'), ('50', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '15', '1531645730'), ('51', '7', 'yes\\n\n', '', '0', '358', '1531645730'), ('52', '1', '', 'Process exited with status 1:', '-1', '398', '1531645730'), ('53', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20522 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10239 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28986522 (27.6 MiB)  TX bytes:707657 (691.0 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '424', '1531645730'), ('54', '1', '', 'Process exited with status 1:', '-1', '258', '1531645732'), ('55', '1', '', 'Process exited with status 1:', '-1', '345', '1531645734'), ('56', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663546 41176068   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '10', '1531645735'), ('57', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645735'), ('58', '7', 'yes\\n\n', '', '0', '359', '1531645735'), ('59', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20610 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10302 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:28997130 (27.6 MiB)  TX bytes:720355 (703.4 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '379', '1531645735'), ('60', '1', '', 'Process exited with status 1:', '-1', '248', '1531645736'), ('61', '1', '', 'Process exited with status 1:', '-1', '247', '1531645738'), ('62', '6', '', '', '0', '9', '1531645740'), ('63', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663546 41176068   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645740'), ('64', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645740'), ('65', '7', 'yes\\n\n', '', '0', '421', '1531645740'), ('66', '1', '', 'Process exited with status 1:', '-1', '502', '1531645740'), ('67', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20726 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10384 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29011194 (27.6 MiB)  TX bytes:737067 (719.7 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '525', '1531645740'), ('68', '1', '', 'Process exited with status 1:', '-1', '218', '1531645742'), ('69', '1', '', 'Process exited with status 1:', '-1', '255', '1531645744'), ('70', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645745'), ('71', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663546 41176068   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645745'), ('72', '7', 'yes\\n\n', '', '0', '331', '1531645745'), ('73', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20813 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10442 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29021684 (27.6 MiB)  TX bytes:749413 (731.8 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '396', '1531645745'), ('74', '1', '', 'Process exited with status 1:', '-1', '313', '1531645746'), ('75', '1', '', 'Process exited with status 1:', '-1', '297', '1531645748'), ('76', '6', '', '', '0', '13', '1531645750'), ('77', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '12', '1531645750'), ('78', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663549 41176065   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '10', '1531645750'), ('79', '7', 'yes\\n\n', '', '0', '323', '1531645750'), ('80', '1', '', 'Process exited with status 1:', '-1', '368', '1531645750'), ('81', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:20929 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10526 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29035690 (27.6 MiB)  TX bytes:766245 (748.2 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '398', '1531645750'), ('82', '1', '', 'Process exited with status 1:', '-1', '247', '1531645752'), ('83', '1', '', 'Process exited with status 1:', '-1', '231', '1531645754'), ('84', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645755'), ('85', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663554 41176060   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645755'), ('86', '7', 'yes\\n\n', '', '0', '343', '1531645755'), ('87', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21018 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10588 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29046358 (27.7 MiB)  TX bytes:778889 (760.6 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '365', '1531645755'), ('88', '1', '', 'Process exited with status 1:', '-1', '245', '1531645756'), ('89', '1', '', 'Process exited with status 1:', '-1', '239', '1531645758'), ('90', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645760'), ('91', '6', '', '', '0', '13', '1531645760'), ('92', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663567 41176047   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '19', '1531645760'), ('93', '1', '', 'Process exited with status 1:', '-1', '428', '1531645760'), ('94', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21135 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10671 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29060424 (27.7 MiB)  TX bytes:795603 (776.9 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '466', '1531645760'), ('95', '7', 'yes\\n\n', '', '0', '522', '1531645760'), ('96', '1', '', 'Process exited with status 1:', '-1', '348', '1531645762'), ('97', '1', '', 'Process exited with status 1:', '-1', '238', '1531645764'), ('98', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645765'), ('99', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663567 41176047   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645765'), ('100', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21224 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10735 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29070976 (27.7 MiB)  TX bytes:808361 (789.4 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '323', '1531645765'), ('101', '7', 'yes\\n\n', '', '0', '367', '1531645765'), ('102', '1', '', 'Process exited with status 1:', '-1', '244', '1531645766'), ('103', '1', '', 'Process exited with status 1:', '-1', '265', '1531645768'), ('104', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645770'), ('105', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663575 41176039   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '11', '1531645770'), ('106', '6', '', '', '0', '18', '1531645770'), ('107', '7', 'yes\\n\n', '', '0', '397', '1531645770'), ('108', '1', '', 'Process exited with status 1:', '-1', '439', '1531645770'), ('109', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21339 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10818 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29084922 (27.7 MiB)  TX bytes:825069 (805.7 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '452', '1531645770'), ('110', '1', '', 'Process exited with status 1:', '-1', '236', '1531645772'), ('111', '1', '', 'Process exited with status 1:', '-1', '253', '1531645774'), ('112', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645775'), ('113', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663575 41176039   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '14', '1531645775'), ('114', '7', 'yes\\n\n', '', '0', '337', '1531645775'), ('115', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21426 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10879 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29095470 (27.7 MiB)  TX bytes:837653 (818.0 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '392', '1531645775'), ('116', '1', '', 'Process exited with status 1:', '-1', '278', '1531645776'), ('117', '1', '', 'Process exited with status 1:', '-1', '259', '1531645778'), ('118', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663575 41176039   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645780'), ('119', '6', '', '', '0', '15', '1531645780'), ('120', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '20', '1531645780'), ('121', '7', 'yes\\n\n', '', '0', '486', '1531645780'), ('122', '1', '', 'Process exited with status 1:', '-1', '511', '1531645780'), ('123', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21542 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:10966 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29109534 (27.7 MiB)  TX bytes:854659 (834.6 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '531', '1531645780'), ('124', '1', '', 'Process exited with status 1:', '-1', '441', '1531645782'), ('125', '1', '', 'Process exited with status 1:', '-1', '268', '1531645784'), ('126', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645785'), ('127', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663575 41176039   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645785'), ('128', '7', 'yes\\n\n', '', '0', '403', '1531645785'), ('129', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21629 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11030 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29120024 (27.7 MiB)  TX bytes:867359 (847.0 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '483', '1531645785'), ('130', '1', '', 'Process exited with status 1:', '-1', '233', '1531645786'), ('131', '1', '', 'Process exited with status 1:', '-1', '283', '1531645788'), ('132', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645790'), ('133', '6', '', '', '0', '12', '1531645790'), ('134', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663577 41176037   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645790'), ('135', '7', 'yes\\n\n', '', '0', '488', '1531645790'), ('136', '1', '', 'Process exited with status 1:', '-1', '498', '1531645790'), ('137', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21747 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11116 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29134208 (27.7 MiB)  TX bytes:884299 (863.5 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '520', '1531645790'), ('138', '1', '', 'Process exited with status 1:', '-1', '266', '1531645792'), ('139', '1', '', 'Process exited with status 1:', '-1', '252', '1531645794'), ('140', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663580 41176034   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '10', '1531645795'), ('141', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645795'), ('142', '7', 'yes\\n\n', '', '0', '334', '1531645795'), ('143', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21836 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11179 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29144876 (27.7 MiB)  TX bytes:896997 (875.9 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '355', '1531645795'), ('144', '1', '', 'Process exited with status 1:', '-1', '231', '1531645796'), ('145', '1', '', 'Process exited with status 1:', '-1', '271', '1531645798'), ('146', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663580 41176034   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '16', '1531645800'), ('147', '6', '', '', '0', '23', '1531645800'), ('148', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '25', '1531645800'), ('149', '7', 'yes\\n\n', '', '0', '348', '1531645800'), ('150', '1', '', 'Process exited with status 1:', '-1', '404', '1531645800'), ('151', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:21949 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11258 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29158528 (27.8 MiB)  TX bytes:913355 (891.9 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '430', '1531645800'), ('152', '1', '', 'Process exited with status 1:', '-1', '290', '1531645802'), ('153', '1', '', 'Process exited with status 1:', '-1', '232', '1531645804'), ('154', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645805'), ('155', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663580 41176034   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645805'), ('156', '7', 'yes\\n\n', '', '0', '346', '1531645805'), ('157', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22039 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11321 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29169256 (27.8 MiB)  TX bytes:926059 (904.3 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '393', '1531645805'), ('158', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663583 41176031   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '11', '1531645810'), ('159', '6', '', '', '0', '15', '1531645810'), ('160', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '19', '1531645810'), ('161', '7', 'yes\\n\n', '', '0', '395', '1531645810'), ('162', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22080 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11352 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29174734 (27.8 MiB)  TX bytes:932881 (911.0 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '405', '1531645810'), ('163', '1', '', 'Process exited with status 1:', '-1', '5284', '1531645806'), ('164', '1', '', 'Process exited with status 1:', '-1', '254', '1531645812'), ('165', '1', '', 'Process exited with status 1:', '-1', '254', '1531645814'), ('166', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '14', '1531645815'), ('167', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663587 41176027   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '14', '1531645815'), ('168', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22185 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11427 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29186838 (27.8 MiB)  TX bytes:947354 (925.1 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '321', '1531645815'), ('169', '7', 'yes\\n\n', '', '0', '341', '1531645815'), ('170', '1', '', 'Process exited with status 1:', '-1', '235', '1531645816'), ('171', '1', '', 'Process exited with status 1:', '-1', '237', '1531645818'), ('172', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663587 41176027   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645820'), ('173', '6', '', '', '0', '16', '1531645820'), ('174', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '16', '1531645820'), ('175', '7', 'yes\\n\n', '', '0', '405', '1531645820'), ('176', '1', '', 'Process exited with status 1:', '-1', '470', '1531645820'), ('177', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22301 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11511 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29200844 (27.8 MiB)  TX bytes:964180 (941.5 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '511', '1531645820'), ('178', '1', '', 'Process exited with status 1:', '-1', '336', '1531645822'), ('179', '1', '', 'Process exited with status 1:', '-1', '275', '1531645824'), ('180', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645825'), ('181', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663589 41176025   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '14', '1531645825'), ('182', '7', 'yes\\n\n', '', '0', '362', '1531645825'), ('183', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22390 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11574 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29211592 (27.8 MiB)  TX bytes:976986 (954.0 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '412', '1531645825'), ('184', '1', '', 'Process exited with status 1:', '-1', '325', '1531645826'), ('185', '1', '', 'Process exited with status 1:', '-1', '380', '1531645828'), ('186', '6', '', '', '0', '12', '1531645830'), ('187', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '10', '1531645830'), ('188', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663589 41176025   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '20', '1531645830'), ('189', '7', 'yes\\n\n', '', '0', '363', '1531645830'), ('190', '1', '', 'Process exited with status 1:', '-1', '404', '1531645830'), ('191', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22506 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11657 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29225482 (27.8 MiB)  TX bytes:993642 (970.3 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '430', '1531645830'), ('192', '1', '', 'Process exited with status 1:', '-1', '263', '1531645832'), ('193', '1', '', 'Process exited with status 1:', '-1', '239', '1531645834'), ('194', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '9', '1531645835'), ('195', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663589 41176025   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645835'), ('196', '7', 'yes\\n\n', '', '0', '335', '1531645835'), ('197', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22594 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11720 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29236090 (27.8 MiB)  TX bytes:1006340 (982.7 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '360', '1531645835'), ('198', '1', '', 'Process exited with status 1:', '-1', '320', '1531645836'), ('199', '1', '', 'Process exited with status 1:', '-1', '271', '1531645838'), ('200', '6', '', '', '0', '22', '1531645840'), ('201', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663601 41176013   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '24', '1531645840'), ('202', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '28', '1531645840'), ('203', '7', 'yes\\n\n', '', '0', '487', '1531645840'), ('204', '1', '', 'Process exited with status 1:', '-1', '565', '1531645840'), ('205', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22711 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11805 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29250156 (27.8 MiB)  TX bytes:1023168 (999.1 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '598', '1531645840'), ('206', '1', '', 'Process exited with status 1:', '-1', '229', '1531645842'), ('207', '1', '', 'Process exited with status 1:', '-1', '239', '1531645844'), ('208', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '17', '1531645845'), ('209', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663603 41176011   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '26', '1531645845'), ('210', '7', 'yes\\n\n', '', '0', '528', '1531645845'), ('211', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22796 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11865 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29260526 (27.9 MiB)  TX bytes:1035640 (1011.3 KiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '604', '1531645845'), ('212', '1', '', 'Process exited with status 1:', '-1', '287', '1531645846'), ('213', '1', '', 'Process exited with status 1:', '-1', '416', '1531645848'), ('214', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '14', '1531645850'), ('215', '6', '', '', '0', '17', '1531645850'), ('216', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663603 41176011   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '19', '1531645850'), ('217', '7', 'yes\\n\n', '', '0', '352', '1531645850'), ('218', '1', '', 'Process exited with status 1:', '-1', '464', '1531645850'), ('219', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:22904 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:11945 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29273836 (27.9 MiB)  TX bytes:1051376 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '477', '1531645850'), ('220', '1', '', 'Process exited with status 1:', '-1', '363', '1531645852'), ('221', '1', '', 'Process exited with status 1:', '-1', '305', '1531645854'), ('222', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645855'), ('223', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663596 41176018   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      642        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645855'), ('224', '7', 'yes\\n\n', '', '0', '357', '1531645855'), ('225', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23001 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12013 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29285142 (27.9 MiB)  TX bytes:1065162 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '415', '1531645855'), ('226', '1', '', 'Process exited with status 1:', '-1', '237', '1531645856'), ('227', '1', '', 'Process exited with status 1:', '-1', '350', '1531645858'), ('228', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '21', '1531645860'), ('229', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663600 41176014   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '24', '1531645860'), ('230', '6', '', '', '0', '31', '1531645860'), ('231', '7', 'yes\\n\n', '', '0', '462', '1531645860'), ('232', '1', '', 'Process exited with status 1:', '-1', '552', '1531645860'), ('233', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23116 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12095 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29299088 (27.9 MiB)  TX bytes:1081858 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '569', '1531645860'), ('234', '1', '', 'Process exited with status 1:', '-1', '367', '1531645862'), ('235', '1', '', 'Process exited with status 1:', '-1', '356', '1531645864'), ('236', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '9', '1531645865'), ('237', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663607 41176007   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '12', '1531645865'), ('238', '7', 'yes\\n\n', '', '0', '443', '1531645865'), ('239', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23203 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12159 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29309520 (27.9 MiB)  TX bytes:1094490 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '475', '1531645865'), ('240', '1', '', 'Process exited with status 1:', '-1', '280', '1531645866'), ('241', '1', '', 'Process exited with status 1:', '-1', '261', '1531645868'), ('242', '6', '', '', '0', '10', '1531645870'), ('243', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663611 41176003   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '14', '1531645870'), ('244', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '16', '1531645870'), ('245', '7', 'yes\\n\n', '', '0', '319', '1531645870'), ('246', '1', '', 'Process exited with status 1:', '-1', '425', '1531645870'), ('247', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23320 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12243 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29323644 (27.9 MiB)  TX bytes:1111300 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '449', '1531645870'), ('248', '1', '', 'Process exited with status 1:', '-1', '242', '1531645872'), ('249', '1', '', 'Process exited with status 1:', '-1', '239', '1531645874'), ('250', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663604 41176010   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '11', '1531645875'), ('251', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '12', '1531645875'), ('252', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23406 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12305 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29334016 (27.9 MiB)  TX bytes:1123870 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '359', '1531645875'), ('253', '7', 'yes\\n\n', '', '0', '365', '1531645875'), ('254', '1', '', 'Process exited with status 1:', '-1', '240', '1531645876'), ('255', '1', '', 'Process exited with status 1:', '-1', '248', '1531645878'), ('256', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645880'), ('257', '6', '', '', '0', '15', '1531645880'), ('258', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663610 41176004   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645880'), ('259', '7', 'yes\\n\n', '', '0', '385', '1531645880'), ('260', '1', '', 'Process exited with status 1:', '-1', '440', '1531645880'), ('261', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23521 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12387 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29347904 (27.9 MiB)  TX bytes:1140560 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '461', '1531645880');
INSERT INTO `pp_task_log` VALUES ('262', '1', '', 'Process exited with status 1:', '-1', '350', '1531645882'), ('263', '1', '', 'Process exited with status 1:', '-1', '345', '1531645884'), ('264', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '12', '1531645885'), ('265', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663613 41176001   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645885'), ('266', '7', 'yes\\n\n', '', '0', '534', '1531645885'), ('267', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23609 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12451 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29358454 (27.9 MiB)  TX bytes:1153302 (1.0 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '624', '1531645885'), ('268', '1', '', 'Process exited with status 1:', '-1', '418', '1531645886'), ('269', '1', '', 'Process exited with status 1:', '-1', '292', '1531645888'), ('270', '6', '', '', '0', '20', '1531645890'), ('271', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '25', '1531645890'), ('272', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663496 41176118   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '29', '1531645890'), ('273', '7', 'yes\\n\n', '', '0', '475', '1531645890'), ('274', '1', '', 'Process exited with status 1:', '-1', '596', '1531645890'), ('275', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23727 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12538 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29372522 (28.0 MiB)  TX bytes:1170234 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '642', '1531645890'), ('276', '1', '', 'Process exited with status 1:', '-1', '302', '1531645892'), ('277', '1', '', 'Process exited with status 1:', '-1', '302', '1531645894'), ('278', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663569 41176045   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '10', '1531645895'), ('279', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645895'), ('280', '7', 'yes\\n\n', '', '0', '408', '1531645895'), ('281', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23814 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12599 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29383070 (28.0 MiB)  TX bytes:1182802 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '429', '1531645895'), ('282', '1', '', 'Process exited with status 1:', '-1', '263', '1531645896'), ('283', '1', '', 'Process exited with status 1:', '-1', '333', '1531645898'), ('284', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663573 41176041   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '10', '1531645898'), ('285', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663573 41176041   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '13', '1531645900'), ('286', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '16', '1531645900'), ('287', '6', '', '', '0', '19', '1531645900'), ('288', '7', 'yes\\n\n', '', '0', '371', '1531645900'), ('289', '1', '', 'Process exited with status 1:', '-1', '454', '1531645900'), ('290', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:23933 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12686 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29397256 (28.0 MiB)  TX bytes:1199746 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '472', '1531645900'), ('291', '1', '', 'Process exited with status 1:', '-1', '425', '1531645902'), ('292', '1', '', 'Process exited with status 1:', '-1', '355', '1531645904'), ('293', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663578 41176036   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '22', '1531645905'), ('294', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '21', '1531645905'), ('295', '7', 'yes\\n\n', '', '0', '415', '1531645905'), ('296', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24021 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12750 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29407864 (28.0 MiB)  TX bytes:1212494 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '466', '1531645905'), ('297', '1', '', 'Process exited with status 1:', '-1', '229', '1531645906'), ('298', '1', '', 'Process exited with status 1:', '-1', '281', '1531645908'), ('299', '6', '', '', '0', '12', '1531645910'), ('300', '9', 'Filesystem      Size   Used  Avail Capacity  iused    ifree %iused  Mounted on\n/dev/disk1     465Gi  307Gi  157Gi    67% 80663581 41176033   66%   /\ndevfs          185Ki  185Ki    0Bi   100%      641        0  100%   /dev\nmap -hosts       0Bi    0Bi    0Bi   100%        0        0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%        0        0  100%   /home\n', '', '0', '15', '1531645910'), ('301', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '14', '1531645910'), ('302', '7', 'yes\\n\n', '', '0', '410', '1531645910'), ('303', '1', '', 'Process exited with status 1:', '-1', '475', '1531645910'), ('304', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24134 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12830 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29421632 (28.0 MiB)  TX bytes:1229012 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '491', '1531645910'), ('305', '1', '', 'Process exited with status 1:', '-1', '354', '1531645912'), ('306', '1', '', 'Process exited with status 1:', '-1', '306', '1531645914'), ('307', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645915'), ('308', '7', 'yes\\n\n', '', '0', '336', '1531645915'), ('309', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24217 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12890 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29431708 (28.0 MiB)  TX bytes:1241404 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '433', '1531645915'), ('310', '1', '', 'Process exited with status 1:', '-1', '242', '1531645916'), ('311', '1', '', 'Process exited with status 1:', '-1', '338', '1531645918'), ('312', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '13', '1531645920'), ('313', '7', 'yes\\n\n', '', '0', '506', '1531645920'), ('314', '1', '', 'Process exited with status 1:', '-1', '564', '1531645920'), ('315', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24335 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12975 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29445892 (28.0 MiB)  TX bytes:1258268 (1.1 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '596', '1531645920'), ('316', '1', '', 'Process exited with status 1:', '-1', '307', '1531645922'), ('317', '1', '', 'Process exited with status 1:', '-1', '353', '1531645924'), ('318', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645925'), ('319', '7', 'yes\\n\n', '', '0', '443', '1531645925'), ('320', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24425 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13039 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29456620 (28.0 MiB)  TX bytes:1271016 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '502', '1531645925'), ('321', '1', '', 'Process exited with status 1:', '-1', '247', '1531645926'), ('322', '1', '', 'Process exited with status 1:', '-1', '282', '1531645928'), ('323', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645930'), ('324', '7', 'yes\\n\n', '', '0', '325', '1531645930'), ('325', '1', '', 'Process exited with status 1:', '-1', '414', '1531645930'), ('326', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24542 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13124 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29470744 (28.1 MiB)  TX bytes:1287886 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '437', '1531645930'), ('327', '1', '', 'Process exited with status 1:', '-1', '282', '1531645932'), ('328', '1', '', 'Process exited with status 1:', '-1', '346', '1531645934'), ('329', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645935'), ('330', '7', 'yes\\n\n', '', '0', '406', '1531645935'), ('331', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24631 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13188 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29481412 (28.1 MiB)  TX bytes:1300622 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '431', '1531645935'), ('332', '1', '', 'Process exited with status 1:', '-1', '254', '1531645936'), ('333', '1', '', 'Process exited with status 1:', '-1', '242', '1531645938'), ('334', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645940'), ('335', '7', 'yes\\n\n', '', '0', '343', '1531645940'), ('336', '1', '', 'Process exited with status 1:', '-1', '432', '1531645940'), ('337', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24743 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13268 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29495120 (28.1 MiB)  TX bytes:1317088 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '449', '1531645940'), ('338', '1', '', 'Process exited with status 1:', '-1', '242', '1531645942'), ('339', '1', '', 'Process exited with status 1:', '-1', '282', '1531645944'), ('340', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645945'), ('341', '7', 'yes\\n\n', '', '0', '445', '1531645945'), ('342', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24829 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13328 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29505550 (28.1 MiB)  TX bytes:1329538 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '509', '1531645945'), ('343', '1', '', 'Process exited with status 1:', '-1', '325', '1531645946'), ('344', '1', '', 'Process exited with status 1:', '-1', '267', '1531645948'), ('345', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '11', '1531645950'), ('346', '7', 'yes\\n\n', '', '0', '498', '1531645950'), ('347', '1', '', 'Process exited with status 1:', '-1', '542', '1531645950'), ('348', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:24948 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13413 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29519794 (28.1 MiB)  TX bytes:1346402 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '564', '1531645950'), ('349', '1', '', 'Process exited with status 1:', '-1', '295', '1531645952'), ('350', '1', '', 'Process exited with status 1:', '-1', '282', '1531645954'), ('351', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645955'), ('352', '7', 'yes\\n\n', '', '0', '396', '1531645955'), ('353', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25037 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13476 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29530462 (28.1 MiB)  TX bytes:1359078 (1.2 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '451', '1531645955'), ('354', '1', '', 'Process exited with status 1:', '-1', '285', '1531645956'), ('355', '1', '', 'Process exited with status 1:', '-1', '362', '1531645958'), ('356', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645960'), ('357', '7', 'yes\\n\n', '', '0', '318', '1531645960'), ('358', '1', '', 'Process exited with status 1:', '-1', '396', '1531645960'), ('359', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25153 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13559 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29544526 (28.1 MiB)  TX bytes:1375828 (1.3 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '410', '1531645960'), ('360', '1', '', 'Process exited with status 1:', '-1', '337', '1531645962'), ('361', '1', '', 'Process exited with status 1:', '-1', '465', '1531645964'), ('362', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645965'), ('363', '7', 'yes\\n\n', '', '0', '368', '1531645965'), ('364', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25242 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13622 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29555194 (28.1 MiB)  TX bytes:1388510 (1.3 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '461', '1531645965'), ('365', '1', '', 'Process exited with status 1:', '-1', '291', '1531645966'), ('366', '1', '', 'Process exited with status 1:', '-1', '340', '1531645968'), ('367', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '7', '1531645970'), ('368', '7', 'yes\\n\n', '', '0', '438', '1531645970'), ('369', '1', '', 'Process exited with status 1:', '-1', '493', '1531645970'), ('370', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25359 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13709 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29569202 (28.1 MiB)  TX bytes:1405494 (1.3 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '507', '1531645970'), ('371', '1', '', 'Process exited with status 1:', '-1', '316', '1531645972'), ('372', '1', '', 'Process exited with status 1:', '-1', '273', '1531645974'), ('373', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531645975'), ('374', '7', 'yes\\n\n', '', '0', '558', '1531645975'), ('375', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25441 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13767 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29579276 (28.2 MiB)  TX bytes:1417766 (1.3 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '618', '1531645975'), ('376', '1', '', 'Process exited with status 1:', '-1', '342', '1531645976'), ('377', '1', '', 'Process exited with status 1:', '-1', '422', '1531645978'), ('378', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '15', '1531645980'), ('379', '7', 'yes\\n\n', '', '0', '489', '1531645980'), ('380', '1', '', 'Process exited with status 1:', '-1', '544', '1531645980'), ('381', '8', 'eth1      Link encap:Ethernet  HWaddr 00:0C:29:CB:2C:63  \n          inet addr:172.16.210.153  Bcast:172.16.210.255  Mask:255.255.255.0\n          inet6 addr: fe80::20c:29ff:fecb:2c63/64 Scope:Link\n          UP BROADCAST RUNNING MULTICAST  MTU:1500  Metric:1\n          RX packets:25559 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:13853 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:1000 \n          RX bytes:29593402 (28.2 MiB)  TX bytes:1434638 (1.3 MiB)\n\nlo        Link encap:Local Loopback  \n          inet addr:127.0.0.1  Mask:255.0.0.0\n          inet6 addr: ::1/128 Scope:Host\n          UP LOOPBACK RUNNING  MTU:65536  Metric:1\n          RX packets:12 errors:0 dropped:0 overruns:0 frame:0\n          TX packets:12 errors:0 dropped:0 overruns:0 carrier:0\n          collisions:0 txqueuelen:0 \n          RX bytes:624 (624.0 b)  TX bytes:624 (624.0 b)\n\n', '', '0', '586', '1531645980'), ('382', '1', '', 'Process exited with status 1:', '-1', '343', '1531645982'), ('383', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '72', '1531722850'), ('384', '4', '', 'exit status 127:sh: tthh: command not found\n', '-1', '8', '1531722855'), ('385', '6', '', '', '0', '21', '1531722930'), ('386', '9', 'Filesystem      Size   Used  Avail Capacity iused               ifree %iused  Mounted on\n/dev/disk1s1   233Gi   44Gi  183Gi    20%  827232 9223372036853948575    0%   /\ndevfs          185Ki  185Ki    0Bi   100%     640                   0  100%   /dev\n/dev/disk1s4   233Gi  5.0Gi  183Gi     3%       4 9223372036854775803    0%   /private/var/vm\nmap -hosts       0Bi    0Bi    0Bi   100%       0                   0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%       0                   0  100%   /home\n', '', '0', '31', '1531722930'), ('387', '9', 'Filesystem      Size   Used  Avail Capacity iused               ifree %iused  Mounted on\n/dev/disk1s1   233Gi   44Gi  183Gi    20%  827232 9223372036853948575    0%   /\ndevfs          185Ki  185Ki    0Bi   100%     640                   0  100%   /dev\n/dev/disk1s4   233Gi  5.0Gi  183Gi     3%       4 9223372036854775803    0%   /private/var/vm\nmap -hosts       0Bi    0Bi    0Bi   100%       0                   0  100%   /net\nmap auto_home    0Bi    0Bi    0Bi   100%       0                   0  100%   /home\n', '', '0', '13', '1531722935'), ('388', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '39', '1533777088'), ('389', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '25', '1533777370'), ('390', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '36', '1533777450'), ('391', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '22', '1533777561'), ('392', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '23', '1533777649'), ('393', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '21', '1533777745'), ('394', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '21', '1533777807'), ('395', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '19', '1533777859'), ('396', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '28', '1533778322'), ('397', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '38', '1533779412'), ('398', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '21', '1533779580'), ('399', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '51', '1533780177'), ('400', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '25', '1533780374'), ('401', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '27', '1533780731'), ('402', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '31', '1533781149'), ('403', '10', '', 'exit status 127:sh: ls-s: command not found\n', '-1', '33', '1533781493'), ('404', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1017', '1533781700'), ('405', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1010', '1533782997'), ('406', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1009', '1533783102'), ('407', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1010', '1533783421'), ('408', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1008', '1533783662'), ('409', '10', '', '任务执行超过 1 秒\n----------------------\nsh: lsss: command not found\n\n', '-2', '1012', '1533783831');
COMMIT;

-- ----------------------------
--  Table structure for `pp_task_server`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task_server`;
CREATE TABLE `pp_task_server` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `group_id` int(64) NOT NULL,
  `server_name` varchar(64) NOT NULL DEFAULT '0' COMMENT '服务器名称',
  `server_account` varchar(32) NOT NULL DEFAULT 'root' COMMENT '账户名称',
  `server_outer_ip` varchar(20) NOT NULL DEFAULT '0' COMMENT '外网IP',
  `server_ip` varchar(20) NOT NULL DEFAULT '0' COMMENT '服务器内网IP',
  `port` int(4) unsigned NOT NULL DEFAULT '22' COMMENT '服务器端口',
  `password` varchar(64) NOT NULL DEFAULT '0' COMMENT '服务器密码',
  `private_key_src` varchar(128) NOT NULL DEFAULT '0' COMMENT '私钥文件地址',
  `public_key_src` varchar(128) NOT NULL DEFAULT '0' COMMENT '公钥地址',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '登录类型：0-密码登录，1-私钥登录',
  `detail` varchar(255) NOT NULL DEFAULT '0' COMMENT '备注',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(11) NOT NULL DEFAULT '0' COMMENT '更新时间',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '状态：0-正常，1-删除',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='服务器列表';

-- ----------------------------
--  Records of `pp_task_server`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task_server` VALUES ('1', '2', '密钥验证服务器', 'root', '0', '172.16.210.168', '22', '', '/Users/haodaquan/.ssh/my_service', '/Users/haodaquan/.ssh/my_service.pub', '1', '远程服务器示例', '1531642563', '1531642563', '0'), ('2', '1', '密码验证服务器', 'root', '0', '172.16.210.153', '22', 'haodaquan2008', '', '', '0', '这是密码验证服务器', '1502945869', '1531618335', '0'), ('3', '3', '测试服务器', 'root', '0', '172.16.210.153', '22', 'haodaquan2008', '', '', '0', '测试服务器', '1531641591', '1531641591', '0');
COMMIT;

-- ----------------------------
--  Table structure for `pp_task_server_group`
-- ----------------------------
DROP TABLE IF EXISTS `pp_task_server_group`;
CREATE TABLE `pp_task_server_group` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `group_name` varchar(50) NOT NULL DEFAULT '0' COMMENT '组名',
  `description` varchar(255) NOT NULL DEFAULT '' COMMENT '说明',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '1-正常，0-删除',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  `create_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '用户ID',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新id',
  PRIMARY KEY (`id`),
  KEY `idx_user_id` (`create_id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;

-- ----------------------------
--  Records of `pp_task_server_group`
-- ----------------------------
BEGIN;
INSERT INTO `pp_task_server_group` VALUES ('1', '资源A组', '服务器A组', '1', '1531617485', '1531617485', '1', '1'), ('2', '资源B组', '服务器B组', '1', '1531617507', '1531617507', '1', '1'), ('3', '资源C组', '资源C组', '1', '1531617530', '1531617530', '1', '1');
COMMIT;

-- ----------------------------
--  Table structure for `pp_uc_admin`
-- ----------------------------
DROP TABLE IF EXISTS `pp_uc_admin`;
CREATE TABLE `pp_uc_admin` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `login_name` varchar(20) NOT NULL DEFAULT '' COMMENT '用户名',
  `real_name` varchar(32) NOT NULL DEFAULT '0' COMMENT '真实姓名',
  `password` char(32) NOT NULL DEFAULT '' COMMENT '密码',
  `role_ids` varchar(255) NOT NULL DEFAULT '0' COMMENT '角色id字符串，如：2,3,4',
  `phone` varchar(20) NOT NULL DEFAULT '0' COMMENT '手机号码',
  `email` varchar(50) NOT NULL DEFAULT '' COMMENT '邮箱',
  `salt` char(10) NOT NULL DEFAULT '' COMMENT '密码盐',
  `last_login` int(11) NOT NULL DEFAULT '0' COMMENT '最后登录时间',
  `last_ip` char(15) NOT NULL DEFAULT '' COMMENT '最后登录IP',
  `status` tinyint(4) NOT NULL DEFAULT '0' COMMENT '状态，1-正常 0禁用',
  `create_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建者ID',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改者ID',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_user_name` (`login_name`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8mb4 COMMENT='管理员表';

-- ----------------------------
--  Records of `pp_uc_admin`
-- ----------------------------
BEGIN;
INSERT INTO `pp_uc_admin` VALUES ('1', 'admin', '超级管理员', 'abfcf6dcedfb4b5b1505d41a8b4c77e8', '0', '13811551087', 'haodaquan2008@163.com', 'aYk4Q1P83v', '1533546302', '[', '1', '0', '1', '0', '1528462051'), ('2', 'test_1', 'pipi', 'b937149452da9f7a36f304dc00149edc', '1', '13811551087', 'haodaquan2008@163.com', '1Uep', '1531645875', '[', '1', '1', '1', '1528459479', '1533703722'), ('3', 'test_ppgo2', 'ppgo2', '5fc38807c6740436407bf80015a7cf06', '2', '13811889999', '333@123.com', 'Qph1', '0', '', '1', '1', '1', '1531645748', '1531645748'), ('4', 'test_ppgo3', 'ppgo3', '548a12147d443ea5a99a65ad4dd1ed30', '3', '13999990000', '222@123.com', '9Xta', '1531645939', '[', '1', '1', '1', '1531645785', '1531645785'), ('5', 'test_ppgo4', 'ppgo4', '3225f516ea8a1c27d695084e0b67b651', '2,1', '13777777999', '44@qq.com', '7QmD', '1531705759', '[', '1', '1', '1', '1531645832', '1531645832');
COMMIT;

-- ----------------------------
--  Table structure for `pp_uc_auth`
-- ----------------------------
DROP TABLE IF EXISTS `pp_uc_auth`;
CREATE TABLE `pp_uc_auth` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '自增ID',
  `pid` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '上级ID，0为顶级',
  `auth_name` varchar(64) NOT NULL DEFAULT '0' COMMENT '权限名称',
  `auth_url` varchar(255) NOT NULL DEFAULT '0' COMMENT 'URL地址',
  `sort` int(1) unsigned NOT NULL DEFAULT '999' COMMENT '排序，越小越前',
  `icon` varchar(255) NOT NULL,
  `is_show` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '是否显示，0-隐藏，1-显示',
  `user_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '操作者ID',
  `create_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建者ID',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改者ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态，1-正常，0-删除',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建时间',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '更新时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=61 DEFAULT CHARSET=utf8mb4 COMMENT='权限因子';

-- ----------------------------
--  Records of `pp_uc_auth`
-- ----------------------------
BEGIN;
INSERT INTO `pp_uc_auth` VALUES ('1', '0', '所有权限', '/', '1', '', '0', '1', '1', '1', '1', '1505620970', '1505620970'), ('2', '1', '权限管理', '/', '999', 'fa-id-card', '1', '1', '0', '1', '1', '0', '1505622360'), ('3', '2', '用户管理', '/admin/list', '1', 'fa-user-o', '1', '0', '0', '0', '1', '0', '1528385411'), ('4', '2', '角色管理', '/role/list', '2', 'fa-user-circle-o', '1', '1', '0', '1', '1', '0', '1505621852'), ('5', '3', '新增', '/admin/add', '1', '', '0', '1', '0', '1', '1', '0', '1505621685'), ('6', '3', '修改', '/admin/edit', '2', '', '0', '1', '0', '1', '1', '0', '1505621697'), ('7', '3', '删除', '/admin/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1505621756', '1505621756'), ('8', '4', '新增', '/role/add', '1', '', '1', '1', '0', '1', '1', '0', '1505698716'), ('9', '4', '修改', '/role/edit', '2', '', '0', '1', '1', '1', '1', '1505621912', '1505621912'), ('10', '4', '删除', '/role/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1505621951', '1505621951'), ('11', '2', '权限因子', '/auth/list', '3', 'fa-list', '1', '1', '1', '1', '1', '1505621986', '1505621986'), ('12', '11', '新增', '/auth/add', '1', '', '0', '1', '1', '1', '1', '1505622009', '1505622009'), ('13', '11', '修改', '/auth/edit', '2', '', '0', '1', '1', '1', '1', '1505622047', '1505622047'), ('14', '11', '删除', '/auth/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1505622111', '1505622111'), ('15', '1', '个人中心', 'profile/edit', '1001', 'fa-user-circle-o', '1', '1', '0', '1', '1', '0', '1506001114'), ('16', '15', '资料修改', '/user/edit', '1', 'fa-edit', '1', '0', '0', '0', '1', '1528385551', '1528385551'), ('17', '1', '基本设置', '/', '2', 'fa-cogs', '1', '1', '0', '1', '1', '0', '1528464467'), ('18', '17', '资源分组', '/servergroup/list', '2', 'fa-cubes', '1', '1', '0', '1', '1', '0', '1528466663'), ('19', '17', '资源管理', '/server/list', '1', 'fa-cube', '1', '1', '0', '1', '1', '0', '1528464498'), ('20', '17', '禁用命令', '/ban/list', '3', 'fa-exclamation-triangle', '1', '1', '0', '1', '1', '0', '1528464656'), ('21', '18', '新增', '/servergroup/add', '1', '', '0', '1', '0', '1', '1', '0', '1528466669'), ('22', '18', '修改', '/servergroup/edit', '2', '', '0', '1', '0', '1', '1', '0', '1528466675'), ('23', '18', '删除', '/servergroup/ajaxdel', '3', '', '0', '1', '0', '1', '1', '0', '1528466684'), ('24', '19', '新增', '/server/add', '1', '', '0', '1', '1', '1', '1', '1528464882', '1528464882'), ('25', '19', '修改', '/server/edit', '2', '', '0', '1', '1', '1', '1', '1528464904', '1528464904'), ('26', '19', '删除', '/server/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1528464937', '1528464937'), ('27', '20', '新增', '/ban/add', '1', '', '0', '1', '1', '1', '1', '1528464977', '1528464977'), ('28', '20', '修改', '/ban/edit', '2', '', '0', '1', '1', '1', '1', '1528465005', '1528465005'), ('29', '20', '删除', '/ban/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1528465036', '1528465036'), ('30', '1', '任务管理', '/job/list', '1', 'fa-tasks', '1', '1', '1', '1', '1', '1528639988', '1528639988'), ('31', '30', '任务列表', '/task/list', '1', 'fa-object-ungroup', '1', '1', '0', '1', '1', '0', '1531212830'), ('32', '30', '任务分组', '/group/list', '3', 'fa-object-group', '1', '1', '0', '1', '1', '0', '1531212219'), ('33', '32', '新增', '/group/add', '1', '', '0', '1', '1', '1', '1', '1528640546', '1528640546'), ('34', '32', '编辑', '/group/edit', '2', '', '0', '1', '1', '1', '1', '1528640572', '1528640572'), ('35', '32', '删除', '/group/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1528640604', '1528640604'), ('36', '31', '新增', '/task/add', '1', '', '0', '1', '1', '1', '1', '1528728220', '1528728220'), ('37', '31', '编辑', '/task/edit', '2', '', '0', '1', '1', '1', '1', '1528728251', '1528728251'), ('38', '42', '删除', '/task/ajaxdel', '3', '', '0', '1', '0', '1', '1', '0', '1531279999'), ('39', '31', '查看', '/task/detail', '3', '', '0', '1', '0', '1', '1', '0', '1531279407'), ('40', '42', '审核通过', '/task/ajaxaudit', '5', '', '0', '1', '0', '1', '1', '0', '1531466535'), ('41', '31', '复制', '/task/copy', '5', '', '0', '1', '0', '1', '1', '0', '1531286150'), ('42', '30', '任务审核', '/task/auditlist', '2', 'fa-gavel', '1', '1', '0', '1', '1', '0', '1531212806'), ('43', '42', '批量审核通过', '/task/ajaxbatchaudit', '1', '', '0', '1', '0', '1', '1', '0', '1531466506'), ('44', '42', '批量审核不通过', '/task/ajaxbatchnopass', '2', '', '0', '1', '0', '1', '1', '0', '1531466513'), ('45', '31', '测试执行', '/task/ajaxrun', '4', '', '0', '1', '0', '1', '1', '0', '1531446085'), ('46', '31', '批量暂停', '/task/ajaxbatchpause', '9', '', '0', '1', '0', '1', '1', '0', '1531466394'), ('47', '31', '批量开启', '/task/ajaxbatchstart', '6', '', '0', '1', '0', '1', '1', '0', '1531466385'), ('48', '31', '开启', '/task/ajaxstart', '7', '', '0', '1', '0', '1', '1', '0', '1531466404'), ('49', '31', '暂停', '/task/ajaxpause', '8', '', '0', '1', '0', '1', '1', '0', '1531466411'), ('50', '42', '审核不通过', '/task/ajaxnopass', '6', '', '0', '1', '0', '1', '1', '0', '1531466546'), ('51', '42', '批量删除', '/task/ajaxbatchdel', '4', '', '0', '1', '0', '1', '1', '0', '1531466528'), ('52', '19', '复制', '/server/copy', '3', '', '0', '1', '1', '1', '1', '1531383393', '1531383393'), ('53', '19', '测试', '/server/ajaxtestserver', '5', '', '0', '1', '0', '1', '1', '0', '1531466851'), ('54', '1', '日志管理', '/tasklog/list', '10', 'fa-file-text-o', '0', '1', '1', '1', '1', '1531389296', '1531389296'), ('55', '54', '详情', '/tasklog/detail', '1', '', '0', '1', '1', '1', '1', '1531389347', '1531389347'), ('56', '54', '删除', '/tasklog/ajaxdel', '2', '', '0', '1', '0', '1', '1', '0', '1531466707'), ('57', '17', '提醒设置', '/remind/list', '4', 'fa-bell-o', '1', '1', '1', '1', '0', '1533607960', '1533607960'), ('58', '57', '新增', '/remind/add', '1', '', '0', '1', '1', '1', '1', '1533608257', '1533608257'), ('59', '57', '编辑', '/remind/edit', '2', '', '0', '1', '1', '1', '1', '1533608298', '1533608298'), ('60', '57', '删除', '/remind/ajaxdel', '3', '', '0', '1', '1', '1', '1', '1533608395', '1533608395');
COMMIT;

-- ----------------------------
--  Table structure for `pp_uc_role`
-- ----------------------------
DROP TABLE IF EXISTS `pp_uc_role`;
CREATE TABLE `pp_uc_role` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键ID',
  `role_name` varchar(32) NOT NULL DEFAULT '0' COMMENT '角色名称',
  `detail` varchar(255) NOT NULL DEFAULT '0' COMMENT '备注',
  `server_group_ids` varchar(255) NOT NULL DEFAULT '0' COMMENT '服务器分组权限ids,1,2,3',
  `task_group_ids` varchar(255) NOT NULL DEFAULT '0' COMMENT '任务分组权限ids ,1,2,32',
  `create_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '创建者ID',
  `update_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改这ID',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态1-正常，0-删除',
  `create_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '添加时间',
  `update_time` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '修改时间',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8mb4 COMMENT='角色表';

-- ----------------------------
--  Records of `pp_uc_role`
-- ----------------------------
BEGIN;
INSERT INTO `pp_uc_role` VALUES ('1', '普通管理员', '可以运行和关闭任务', '10,1', '4,1', '0', '1', '1', '1531705962', '1531705962'), ('2', '高级管理员', '可以批量操作任务，创建任务，创建任务分组，审核任务等', ',10,1,2', '4,6,1,2', '0', '1', '1', '1533607237', '1533607237'), ('3', '资深管理员', '系统配置，任务管理等', '1,2,3', '2,1,3', '0', '1', '1', '1531644877', '1531644877');
COMMIT;

-- ----------------------------
--  Table structure for `pp_uc_role_auth`
-- ----------------------------
DROP TABLE IF EXISTS `pp_uc_role_auth`;
CREATE TABLE `pp_uc_role_auth` (
  `role_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '角色ID',
  `auth_id` int(11) unsigned NOT NULL DEFAULT '0' COMMENT '权限ID',
  PRIMARY KEY (`role_id`,`auth_id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 COMMENT='权限和角色关系表';

-- ----------------------------
--  Records of `pp_uc_role_auth`
-- ----------------------------
BEGIN;
INSERT INTO `pp_uc_role_auth` VALUES ('1', '1'), ('1', '15'), ('1', '16'), ('1', '30'), ('1', '31'), ('1', '36'), ('1', '37'), ('1', '39'), ('1', '41'), ('1', '46'), ('1', '47'), ('1', '48'), ('1', '49'), ('1', '54'), ('1', '55'), ('1', '56'), ('2', '0'), ('2', '17'), ('2', '18'), ('2', '19'), ('2', '20'), ('2', '21'), ('2', '22'), ('2', '23'), ('2', '24'), ('2', '25'), ('2', '26'), ('2', '27'), ('2', '28'), ('2', '29'), ('2', '32'), ('2', '33'), ('2', '34'), ('2', '35'), ('2', '38'), ('2', '40'), ('2', '42'), ('2', '43'), ('2', '44'), ('2', '45'), ('2', '50'), ('2', '51'), ('2', '52'), ('2', '53');
COMMIT;

BEGIN;
ALTER TABLE `pp_uc_admin` ADD `dingtalk` VARCHAR(64) NULL COMMENT '钉钉' AFTER `email`;
COMMIT;

BEGIN;
ALTER TABLE `pp_task` ADD `notify_tpl_id` INT NOT NULL DEFAULT '0' COMMENT '通知模板id' AFTER `notify_type`;
COMMIT;

BEGIN;
INSERT INTO `pp_uc_auth` VALUES(61, 17, '通知模板', '/notifytpl/list', 5, 'fa-file-o', 1, 1, 0, 1, 1, 0, 1550237874);
INSERT INTO `pp_uc_auth` VALUES(62, 61, '新增', '/notifytpl/add', 1, '', 0, 1, 0, 1, 1, 0, 1550237919);
INSERT INTO `pp_uc_auth` VALUES(63, 61, '编辑', '/notifytpl/edit', 2, '', 0, 1, 1, 1, 1, 1550237957, 1550237957);
INSERT INTO `pp_uc_auth` VALUES(64, 61, '删除', '/notifytpl/ajaxdel', 3, '', 0, 1, 1, 1, 1, 1550237987, 1550237987);
INSERT INTO `pp_uc_auth` VALUES(65, 31, '通知类型', '/task/ajaxnotifytype', 10, '', 0, 1, 1, 1, 1, 1550258380, 1550258380);
COMMIT;

--
-- 表的结构 `pp_notify_tpl`
--
DROP TABLE IF EXISTS `pp_notify_tpl`;
CREATE TABLE `pp_notify_tpl` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '模板id',
  `type` enum('system','default') CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL DEFAULT 'default',
  `tpl_name` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板名称',
  `tpl_type` tinyint(1) NOT NULL COMMENT '模板类型 0:邮件;1:信息;2:钉钉;3:微信;',
  `title` varchar(64) DEFAULT NULL COMMENT '标题',
  `content` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '模板内容',
  `status` tinyint(1) NOT NULL DEFAULT '1' COMMENT '状态 0:禁用;1:启用;',
  `create_time` int(11) NOT NULL DEFAULT '0' COMMENT '创建时间',
  `create_id` int(11) NOT NULL DEFAULT '0' COMMENT '创建者ID',
  `update_time` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次编辑时间',
  `update_id` int(11) NOT NULL DEFAULT '0' COMMENT '最后一次编辑者ID',
  PRIMARY KEY (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8 COMMENT='通知模板';

--
-- 转存表中的数据 `pp_notify_tpl`
--
BEGIN;
INSERT INTO `pp_notify_tpl` VALUES(1, 'system', '默认邮箱通知模板', 0, '定时任务异常：{{TaskName}}', 'Hello,定时任务出问题了：\r\n<p style=\"font-size:16px;\">任务执行详情：</p>\r\n<p style=\"display:block; padding:10px; background:#efefef;border:1px solid #e4e4e4\">\r\n任务 ID：{{TaskId}}<br/>\r\n任务名称：{{TaskName}}<br/>\r\n执行命令：{{ExecuteCommand}}<br/>\r\n执行时间：{{ExecuteTime}}<br/>\r\n执行耗时：{{ProcessTime}}秒<br/>\r\n执行状态：{{ExecuteStatus}}\r\n</p>\r\n<p style=\"font-size:16px;\">任务执行输出</p>\r\n<p style=\"display:block; padding:10px; background:#efefef;border:1px solid #e4e4e4\">\r\n{{TaskOutput}}\r\n</p>\r\n<p style=\"font-size:16px;\">错误输出</p>\r\n<p style=\"display:block; padding:10px; background:#efefef;border:1px solid #e4e4e4\">\r\n{{ErrorOutput}}\r\n</p>', 1, 1550255030, 1, 1553282382, 1);
INSERT INTO `pp_notify_tpl` VALUES(2, 'system', '默认短信通知模板', 1, '', '{\r\n    \"task_id\": \"{{TaskId}}\",\r\n    \"task_name\": \"{{TaskName}}\",\r\n    \"execute_command\": \"{{ExecuteCommand}}\",\r\n    \"execute_status\": \"{{ExecuteStatus}}\"\r\n}', 1, 1550255030, 1, 1550338215, 1);
INSERT INTO `pp_notify_tpl` VALUES(3, 'system', '默认钉钉通知模板', 2, '', '{\r\n    \"msgtype\": \"text\",\r\n    \"text\": {\r\n        \"content\": \"任务执行异常详情：\\n任务 ID：{{TaskId}}\\n任务名称：{{TaskName}}\\n执行命令：{{ExecuteCommand}}\\n执行时间：{{ExecuteTime}}\\n执行耗时：{{ProcessTime}}秒\\n执行状态：{{ExecuteStatus}}\\n任务执行输出：\\n{{TaskOutput}}\\n错误输出：\\n{{ErrorOutput}}\"\r\n    }\r\n}', 1, 1550255030, 1, 1553282245, 1);
INSERT INTO `pp_notify_tpl` VALUES(4, 'system', '默认微信通知模板', 3, '', '{\r\n    \"task_id\": \"{{TaskId}}\",\r\n    \"task_name\": \"{{TaskName}}\",\r\n    \"execute_command\": \"{{ExecuteCommand}}\",\r\n    \"execute_status\": \"{{ExecuteStatus}}\"\r\n}', 1, 1550347183, 1, 1550347201, 1);
COMMIT;

BEGIN;
ALTER TABLE `pp_task` CHANGE `notify_type` `notify_type` TINYINT(1) UNSIGNED NOT NULL DEFAULT '0' COMMENT '0-邮件通知，1-信息通知，2-钉钉通知，3-微信通知，';
COMMIT;

BEGIN;
ALTER TABLE `pp_uc_admin` ADD `wechat` VARCHAR(64) NULL COMMENT '微信' AFTER `dingtalk`;
COMMIT;

BEGIN;
ALTER TABLE `pp_task_server` ADD `connection_type` TINYINT(1) NOT NULL DEFAULT '0' COMMENT '连接类型 0:SSH;1:Telnet;' AFTER `group_id`;
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
